/*
    A basic extension of the java.awt.Dialog class
 */

import java.awt.*;
import symantec.itools.awt.MultiList;

public class RB_Dialog extends Dialog {
    MultiList ml;
    int pos, from=-1, to=-1;
    RoomSched RS;
    String Mesg,
           oldMesg,
           roomTimes[] = {"8:00am","8:30am","9:00am","9:30am","10:00am","10:30am","11:00am","11:30am",
            			"12:00","12:30pm","1:00pm","1:30pm","2:00pm","2:30pm","3:00pm","3:30pm",
			            "4:00pm","4:30pm","5:00pm","5:30pm","6:00pm"};
    
	void RBERemove_Clicked(Event event) {
        String time = RBE_time.getSelectedItem();
        
	    if (time.length() < 3) {        // only removing current one
       	    RS.roomMessage(false, pos, "");
   	        ml.addTextCell(pos, 1, "");
   	    } 
   	    else {
       	    for (int i=from; i<21; i++) {
                if (roomTimes[i].equals(time)) {
                    for (;i>=from; i--) {
                        time = ml.getCellText(i, 1);
                        if (time.equals(oldMesg)) {
                    	    RS.roomMessage(false, i, "");
                    	}
                    }
                    break;
                }
   	        }
   	    }
   	    ml.redraw();
   	    hide();
	}

	void RBEOK_Clicked(Event event) {
	    String time;
	    boolean flag;
	    
		hide();
		
	    if (Mesg.length() < 1)  // are we adding or updating
	        flag = true;
	    else
	        flag = false;
	        
        time = RBE_time.getSelectedItem();
        if (time.length() > 3) {    // multiple time selection
   	        Mesg = ml.getCellText(pos, 0);
       	    for (int i=from; i<21; i++) {
                if (roomTimes[i].equals(time)) {
               	    Mesg = RBE_Message.getText();
                    for (;i>=from; i--) {
                        time = ml.getCellText(i, 1);
                        if (time.length() < 3 || time.equals(oldMesg)) {
//                            ml.addTextCell(i, 1, Mesg);
                    	    RS.roomMessage(flag, i, Mesg);
                    	}
                    }
//                    ml.redraw();
                    break;
                }
   	        }
   	    }
   	    else {
            Mesg = RBE_Message.getText();
//            ml.addTextCell(pos, 1, Mesg);
     	    RS.roomMessage(flag, pos, Mesg);
   	    }
	    ml.redraw();
		RS.setSelected();

	}

	void RBECancel_Clicked(Event event) {
	    RS.setSelected();
		hide();
	}


	public RB_Dialog(Frame parent, boolean modal) {

	    super(parent, modal);

		//{{INIT_CONTROLS
		setLayout(null);
		addNotify();
		resize(insets().left + insets().right + 409,insets().top + insets().bottom + 144);
		setBackground(new Color(12632256));
		keyPressManagerPanel1 = new symantec.itools.awt.KeyPressManagerPanel();
		keyPressManagerPanel1.setLayout(null);
		keyPressManagerPanel1.reshape(insets().left + 0,insets().top + 0,410,145);
		add(keyPressManagerPanel1);
		RBE_Message = new java.awt.TextField();
		RBE_Message.reshape(100,45,245,25);
		keyPressManagerPanel1.add(RBE_Message);
		label1 = new java.awt.Label("Message:",Label.RIGHT);
		label1.reshape(15,45,80,20);
		keyPressManagerPanel1.add(label1);
		RBE_OK = new java.awt.Button("OK");
		RBE_OK.reshape(50,90,70,30);
		keyPressManagerPanel1.add(RBE_OK);
		RBE_Cancel = new java.awt.Button("Cancel");
		RBE_Cancel.reshape(175,90,70,30);
		keyPressManagerPanel1.add(RBE_Cancel);
		RBE_Remove = new java.awt.Button("Remove");
		RBE_Remove.reshape(300,90,70,30);
		keyPressManagerPanel1.add(RBE_Remove);
		RBE_time = new java.awt.Choice();
		RBE_time.addItem("");
		keyPressManagerPanel1.add(RBE_time);
		RBE_time.reshape(315,10,75,24);
		label2 = new java.awt.Label("Time To:",Label.RIGHT);
		label2.reshape(230,10,80,20);
		keyPressManagerPanel1.add(label2);
		setTitle("Room Booking Screen");
		//}}
		keyPressManagerPanel1.setDefaultButton(RBE_OK);
		keyPressManagerPanel1.setCancelButton(RBE_Cancel);
	}

	public RB_Dialog(Frame parent, String message, boolean modal, MultiList ml, int pos, RoomSched RS) {
	    this(parent, modal);
	    this.ml = ml;
	    this.pos = pos;
	    this.RS = RS;
	    RBE_Message.setText(message);
	    Mesg = ml.getCellText(pos, 0);
	    for (int i=0; i<21; i++) {
	        if (roomTimes[i].equals(Mesg)) {
	            from = i;
	            for (int j=i+1; j<21; j++) {
	                RBE_time.addItem(roomTimes[j]);
	            }
	            break;
	        }
	    }
	    Mesg = new String(message);
	    oldMesg = new String(message);
	}

    public synchronized void show() {
    	Rectangle bounds = getParent().bounds();
    	Rectangle abounds = bounds();

    	move(bounds.x + (bounds.width - abounds.width)/ 2,
    	     bounds.y + (bounds.height - abounds.height)/2);

    	super.show();
    }

	public boolean handleEvent(Event event) {
	    if(event.id == Event.WINDOW_DESTROY) {
	        hide();
	        return true;
	    }
		if (event.target == RBE_Cancel && event.id == Event.ACTION_EVENT) {
			RBECancel_Clicked(event);
			return true;
		}
		if (event.target == RBE_OK && event.id == Event.ACTION_EVENT) {
			RBEOK_Clicked(event);
			return true;
		}
		if (event.target == RBE_Remove && event.id == Event.ACTION_EVENT) {
			RBERemove_Clicked(event);
			return true;
		}
		return super.handleEvent(event);
	}

	//{{DECLARE_CONTROLS
	symantec.itools.awt.KeyPressManagerPanel keyPressManagerPanel1;
	java.awt.TextField RBE_Message;
	java.awt.Label label1;
	java.awt.Button RBE_OK;
	java.awt.Button RBE_Cancel;
	java.awt.Button RBE_Remove;
	java.awt.Choice RBE_time;
	java.awt.Label label2;
	//}}
}