import java.awt.*;
import java.awt.Button;
import java.awt.Frame;
import java.awt.Insets;
import java.awt.Label;
import java.awt.FlowLayout;
import java.net.URL;
import symantec.itools.multimedia.ImageViewer;
import symantec.itools.awt.util.dialog.ModalDialog;

public class RB_ErrorDialog extends ModalDialog {
    Frame parent;
    
	void RBErrorDialog_WindowDestroy(Event event) {
		hide();
	}

	public boolean handleEvent(Event event) {
		if (event.target == RB_E_Button && event.id == Event.ACTION_EVENT) {
			RBEButton_Clicked(event);
			return true;
		}
		if (event.target == this && event.id == Event.WINDOW_DESTROY) {
			RBErrorDialog_WindowDestroy(event);
			return true;
		}
		return super.handleEvent(event);
	}

	void RBEButton_Clicked(Event event) {
		hide();
	}


	public RB_ErrorDialog(Frame parent, String title, String message, URL iconURL) {
		super(parent, title);

		//{{INIT_CONTROLS
		setLayout(null);
		addNotify();
		resize(insets().left + insets().right + 366,insets().top + insets().bottom + 170);
		setBackground(new Color(16711680));
		RB_E_label1 = new java.awt.Label("");
		RB_E_label1.reshape(insets().left + 15,insets().top + 35,340,40);
		add(RB_E_label1);
		RB_E_Button = new java.awt.Button("OK");
		RB_E_Button.reshape(insets().left + 145,insets().top + 95,80,34);
		add(RB_E_Button);
		setTitle("NDP HelpDesk: Error ");
		setResizable(false);
		//}}

		RB_E_label1.setText(message);
		if (iconURL != null) {
			ImageViewer img = new ImageViewer(iconURL);
			add(img);
		}

		this.parent = parent;
	}

	public RB_ErrorDialog(Frame parent) {
		this(parent, "Attention", "Event", null);
	}

	// Add a constructor for Interactions (ignoring modal)
	public RB_ErrorDialog(Frame parent, boolean modal) {
		this(parent);
	}

	// Add a constructor for Interactions (ignoring modal)
	public RB_ErrorDialog(Frame parent, String message, boolean modal) {
		this(parent, "Attention", message, null);
	}

	//{{DECLARE_CONTROLS
	java.awt.Label RB_E_label1;
	java.awt.Button RB_E_Button;
	//}}
}

