/*
    A basic extension of the java.applet.Applet class
 */

import java.awt.*;
import java.applet.*;
import java.util.Date;
import java.util.Vector;
import java.net.*;
import java.io.*;
import java.util.*;
import symantec.itools.awt.DirectionButton;

public class RoomSched extends Applet {
    public static final int PORT = 5000; //
    Frame parent;
    Container theFrame;
    
    int year=-1,
        month=-1,
        day=-1,
        CurSelected=-1,
        UID_len;
    
    String room,
           User_ID,
           SelDate,
           dummy,
           roomTimes[] = {"8:00am","8:30am","9:00am","9:30am","10:00am","10:30am","11:00am","11:30am",
            			"12:00","12:30pm","1:00pm","1:30pm","2:00pm","2:30pm","3:00pm","3:30pm",
			            "4:00pm","4:30pm","5:00pm","5:30pm","6:00pm"},
		   timeHeadings[] = {"Time", "Messages"},
		   roomLocations[] = {"the old library", "near the credit dept", "near Zoe Maye",
		                    "across from Milena", "in the MIS area"};
    
    Graphics graphics;
    
    Vector vdata;
    
    databaseListener databaselistener = null;
    Socket socket;
    
    int DaysInMonth[][] = {{0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31},	// non-leap
	                	   {0, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31}};	// leap

	void RSDirForward_Action(Event event) {
	    int i = RS_cMonth.getSelectedIndex() + 1;
	    if (i < 12) {
    		RS_cMonth.select(i);
    		RSCMonth_Action(event);
        }
	}

	void RSDirBackward_Action(Event event) {
	    int i = RS_cMonth.getSelectedIndex() - 1;
	    if (i >= 0) {
    		RS_cMonth.select(i);
    		RSCMonth_Action(event);
        }
	}

	void RSRoomTimes_Action(Event event) {
	    int i = RS_roomTimes.getSelectedRow();

	    if (i != CurSelected && SelDate.length() != 0) {
	        CurSelected = i;
   	    	RS_roomTimes.setSelectedRow(i);
   	    	dummy = RS_roomTimes.getCellText(i, 1);
   	    	dummy = dummy.trim();
   	    	if (dummy.length() > 0 && (dummy.indexOf(User_ID) != -1 || User_ID.equals("GAULTT")))
           		(new RB_Dialog(parent, dummy, true, RS_roomTimes, i, this)).show();
            else if (dummy.length() == 0)
           		(new RB_Dialog(parent, dummy, true, RS_roomTimes, i, this)).show();
//		label4.setText(RS_roomTimes.getCellText(i, 0));
        }
	}
	
	void roomMessage(boolean addit, int pos, String msg) {
	    if (msg.length() == 0)  {
	        vdata = databaselistener.processRequest("roombook_delete " + room + "|" + SelDate + "|" + RS_roomTimes.getCellText(pos, 0) + "|");
    	    RS_roomTimes.addTextCell(pos, 1, "");
	        return;
    	}
    	
    	if ((UID_len + msg.length()) > 59) {
    	    msg = msg.substring(1, (58-UID_len));
    	}
    	    
	    if (msg.indexOf(User_ID) == -1 && msg.length() > 1) {
    	    msg = msg.concat("/");
	        msg = msg.concat(User_ID);
	    }
	    
	    if (addit == true) {
	        vdata = databaselistener.processRequest("roombook_add " + room + "|" + SelDate + "|" + RS_roomTimes.getCellText(pos, 0)  
	                    + "|" + msg + "|");
	    }
	    else {
	        vdata = databaselistener.processRequest("roombook_update " + room + "|" + SelDate + "|" + RS_roomTimes.getCellText(pos, 0)  
	                    + "|" + msg + "|");
	    }
	    RS_roomTimes.addTextCell(pos, 1, msg);
//	    RS_roomTimes.redraw();
//		setSelected();
	}
	
	void setSelected() {
	    CurSelected = -1;
	}

	void RSCYear_Action(Event event) {
	    year = (RS_cYear.getSelectedIndex()) + 1997;
	    drawCalendar(year, month, day);
	}

	void RSCMonth_Action(Event event) {
	    month = RS_cMonth.getSelectedIndex() + 1;
	    drawCalendar(year, month, day);
	}

	void RSCRoom_Action(Event event) {
	    room = RS_cRoom.getSelectedItem();
	    label5.setText("Location: " + roomLocations[RS_cRoom.getSelectedIndex()]);
	    drawCalendar(year, month, day);
	}

	void RSBOK_Clicked(Event event) {
        vdata = databaselistener.processRequest("quit");
		hide();
		System.exit(0);
	}
	
	void RSBCalendar_Clicked(Event event) {
	    Button bpressed = (Button) event.target;
	    SelDate = bpressed.getLabel()+ RS_cMonth.getSelectedItem() + String.valueOf(year);
	    timeHeadings[1] = "Messages for: " + SelDate;
	    RS_roomTimes.setHeading(timeHeadings[1], 1, 200);
	    getRoomDetails(room, SelDate);
	}
	
	public void getRoomDetails(String room, String date) {
		RS_roomTimes.clear();
	    
	    vdata = databaselistener.processRequest("roombook_query " + room + "|" + date + "|");
		RS_roomTimes.setListItems(roomTimes);
        dummy = (String )vdata.elementAt(0);
        if (dummy.startsWith("ERROR"))
		    return;
		    
		for (int i=vdata.size()-1; i>0; i--) {
   	        StringTokenizer st = new StringTokenizer((String )vdata.elementAt(i-1), "|");
   	        dummy = st.nextToken();
            for (int x=roomTimes.length-1; x>=0; x--) {
                 if (roomTimes[x].equals(dummy))
                    RS_roomTimes.addTextCell(x, 1, st.nextToken());
            }
		}
		RS_roomTimes.redraw();
	}
	
	public void drawCalendar(int year, int month, int day) {
  	Date d = new Date(year-1900, month-1, 1);   // year month day 
	int dayofweek =  d.getDay(),
	    idays; 

        if (isLeapyear(year)) 
    		idays = DaysInMonth[1][month];
    	else
    		idays = DaysInMonth[0][month]; 
    		
        RS_roomCalendar.removeAll();

    	for (int i = 0; i < dayofweek; i++) 
	        RS_roomCalendar.add(new Button(""));

        for (int i = 1; i <= idays; i++) 
	    	RS_roomCalendar.add(new Button("" + i));
	    	
//	    label4.setText("Yr = " + String.valueOf(year) + "  Mth = " + String.valueOf(month));
	    	
        RS_roomCalendar.paintAll(graphics);
	    RS_roomTimes.setHeading("Messages", 1, 200);
		RS_roomTimes.clear();
    }


    public boolean isLeapyear(int year) {
	    if ((year % 100) == 0) 
	        return((year % 400) == 0);
	    return ((year % 4) == 0);
    }

	public void init() {
		super.init();

		// Take out this line if you don't use symantec.itools.net.RelativeURL
//        symantec.itools.lang.Context.setDocumentBase(getDocumentBase());

		//{{INIT_CONTROLS
		setLayout(null);
		addNotify();
		resize(570,416);
		setBackground(new Color(12632256));
		RS_bOK = new java.awt.Button("Exit");
		RS_bOK.reshape(230,385,110,30);
		add(RS_bOK);
		RS_roomCalendar = new java.awt.Panel();
		RS_roomCalendar.setLayout(new GridLayout(0,7,0,0));
		RS_roomCalendar.reshape(5,165,238,210);
		RS_roomCalendar.setBackground(new Color(16777215));
		add(RS_roomCalendar);
		RS_roomTimes = new symantec.itools.awt.MultiList();
		RS_roomTimes.reshape(245,35,320,340);
		add(RS_roomTimes);
		{
			java.lang.String[] tempString = new java.lang.String[2];
			tempString[0] = new java.lang.String("Time");
			tempString[1] = new java.lang.String("Message");
			RS_roomTimes.setHeadings(tempString);
		}
		{
			java.lang.String[] tempString = new java.lang.String[1];
			tempString[0] = new java.lang.String("");
			RS_roomTimes.setListItems(tempString);
		}
		{
			java.lang.String[] tempString = new java.lang.String[2];
			tempString[0] = new java.lang.String("55");
			tempString[1] = new java.lang.String("200");
			RS_roomTimes.setColumnSizes(tempString);
		}
		RS_cMonth = new java.awt.Choice();
		RS_cMonth.addItem("Jan");
		RS_cMonth.addItem("Feb");
		RS_cMonth.addItem("Mar");
		RS_cMonth.addItem("Apr");
		RS_cMonth.addItem("May");
		RS_cMonth.addItem("Jun");
		RS_cMonth.addItem("Jul");
		RS_cMonth.addItem("Aug");
		RS_cMonth.addItem("Sep");
		RS_cMonth.addItem("Oct");
		RS_cMonth.addItem("Nov");
		RS_cMonth.addItem("Dec");
		add(RS_cMonth);
		RS_cMonth.reshape(95,75,75,24);
		RS_cRoom = new java.awt.Choice();
		RS_cRoom.addItem("Mtg Rm1");
		RS_cRoom.addItem("Mtg Rm2");
		RS_cRoom.addItem("Mtg Rm3");
		RS_cRoom.addItem("Fin Rm1");
		RS_cRoom.addItem("MIS Rm1");
		add(RS_cRoom);
		RS_cRoom.reshape(95,40,90,24);
		RS_cYear = new java.awt.Choice();
		RS_cYear.addItem("1997");
		RS_cYear.addItem("1998");
		add(RS_cYear);
		RS_cYear.reshape(95,110,75,24);
		RS_panel = new java.awt.Panel();
		RS_panel.setLayout(new GridLayout(0,7,0,0));
		RS_panel.reshape(5,140,238,20);
		RS_panel.setBackground(new Color(12632256));
		add(RS_panel);
		label1 = new java.awt.Label("Month",Label.RIGHT);
		label1.reshape(40,75,50,25);
		add(label1);
		label2 = new java.awt.Label("Room",Label.RIGHT);
		label2.reshape(40,40,50,25);
		add(label2);
		label3 = new java.awt.Label("Year",Label.RIGHT);
		label3.reshape(50,110,40,25);
		add(label3);
		label4 = new java.awt.Label("Year",Label.CENTER);
		label4.reshape(300,5,205,25);
		add(label4);
		label5 = new java.awt.Label("");
		label5.reshape(35,5,240,25);
		add(label5);
		//}}

		remove(RS_bOK);
		theFrame = this;
		do {
				theFrame = theFrame.getParent();
		} while ((theFrame != null) && !(theFrame instanceof Frame));
		if (theFrame == null)
				theFrame = new Frame();
	    parent = (Frame )theFrame;

        try {
            socket = new Socket("intra", PORT);
        }
        catch (IOException e) {
            (new RB_ErrorDialog(parent, "Unable to Connect to the System", true)).show();
            hide();
            System.exit(0);
        }

        databaselistener = new databaseListener(socket);
        vdata = databaselistener.processRequest("Connect intrauser intraloser RoomBook");
        User_ID = (String )vdata.elementAt(0);
        if (User_ID.startsWith("ERROR") || User_ID.startsWith("Failed") || User_ID.startsWith("Denied")) {
            (new RB_ErrorDialog(parent, User_ID, true)).show();
            hide();
            System.exit(0);
        }
        StringTokenizer st = new StringTokenizer(User_ID.substring(10));
        User_ID = st.nextToken();
        UID_len = User_ID.length();

        graphics = RS_roomCalendar.getGraphics();
		Date now = new Date();
        year = now.getYear() + 1900;
        month = now.getMonth() + 1;
        day = now.getDay();
        RS_cYear.select(String.valueOf(year));
        RS_cMonth.select(month-1);
        drawCalendar(year, month, day);
        room = "Mtg Rm1";
        label5.setText("Location: " + roomLocations[0]);
        SelDate = new String();
        label4.setText("Todays Date is: " + now.toString().substring(0,10));

        RS_dirForward = new DirectionButton(DirectionButton.RIGHT);
        RS_dirForward.reshape(200,70,30,30);
        add(RS_dirForward);
        RS_dirBackward = new DirectionButton(DirectionButton.LEFT);
        RS_dirBackward.reshape(5,70,30,30);
        add(RS_dirBackward);
//  getRoomDetails("Mtg Rm1", "1Sep1997");
	    RS_panel.add(new Label("Sun"));
	    RS_panel.add(new Label("Mon"));
	    RS_panel.add(new Label("Tue"));
	    RS_panel.add(new Label("Wed"));
	    RS_panel.add(new Label("Thu"));
	    RS_panel.add(new Label("Fri"));
	    RS_panel.add(new Label("Sat"));
	}
	/*
    public boolean mouseUp(Event event, int x, int y) {
		if (event.target == RS_roomTimes) {
		    label4.setText("Event = " + String.valueOf(event.id));
//		    return true;
		}
		return super.mouseUp(event, x, y);
    }
    public boolean mouseDown(Event event, int x, int y) {
		if (event.target == RS_roomTimes) {
		    label4.setText("Event = " + String.valueOf(event.id));
//		    return true;
		}
		return super.mouseDown(event, x, y);
    }
*/
	public boolean handleEvent(Event event) {
		if (event.target == RS_bOK && event.id == Event.ACTION_EVENT) {
			RSBOK_Clicked(event);
			return true;
		}
		if (event.target == RS_cRoom && event.id == Event.ACTION_EVENT) {
			RSCRoom_Action(event);
			return true;
		}
		if (event.target == RS_cMonth && event.id == Event.ACTION_EVENT) {
			RSCMonth_Action(event);
			return true;
		}
		if (event.target == RS_cYear && event.id == Event.ACTION_EVENT) {
			RSCYear_Action(event);
			return true;
		}
		if (event.target == RS_roomTimes && event.id == Event.ACTION_EVENT) {
			RSRoomTimes_Action(event);
			return true;
		}
		if (event.target == RS_roomTimes) {
		    label4.setText("Event = " + String.valueOf(event.id));
		}
//		if (event.target == this && event.id == Event.WINDOW_DESTROY) {
//            vdata = databaselistener.processRequest("quit");
//	    	hide();
//	    	System.exit(0);
//		}
		if (event.target instanceof Button && event.id == Event.ACTION_EVENT) {
			RSBCalendar_Clicked(event);
			return true;
		}

		if (event.target == RS_dirBackward && event.id == Event.ACTION_EVENT) {
			RSDirBackward_Action(event);
			return true;
		}
		if (event.target == RS_dirForward && event.id == Event.ACTION_EVENT) {
			RSDirForward_Action(event);
			return true;
		}
		return super.handleEvent(event);
	}

	//{{DECLARE_CONTROLS
	java.awt.Button RS_bOK;
	java.awt.Panel RS_roomCalendar;
	symantec.itools.awt.MultiList RS_roomTimes;
	java.awt.Choice RS_cMonth;
	java.awt.Choice RS_cRoom;
	java.awt.Choice RS_cYear;
	java.awt.Panel RS_panel;
	java.awt.Label label1;
	java.awt.Label label2;
	java.awt.Label label3;
	java.awt.Label label4;
	java.awt.Label label5;
	//}}
	
	symantec.itools.awt.DirectionButton RS_dirForward;
	symantec.itools.awt.DirectionButton RS_dirBackward;
}